#!/bin/sh

remove_icons()
{
    rm /usr/share/icons/varicad"$ADDON".xpm 2>/dev/null
    rm /usr/share/pixmaps/varicad"$ADDON".xpm 2>/dev/null
}

remove_wmconfig()
{  
    rm /etc/X11/wmconfig/varicad"$ADDON" 2>/dev/null
    rm /etc/X11/applnk/varicad"$ADDON".desktop 2>/dev/null
    rm /etc/X11/applnk/$MENU_GROUP/varicad"$ADDON".desktop 2>/dev/null
}

remove_gnome_entries()
{
    rm ${1}/pixmaps/varicad"$ADDON".xpm 2>/dev/null
    rm ${1}/apps/$MENU_GROUP/varicad"$ADDON".desktop 2>/dev/null
}

remove_kde_entries()
{
	DIR_HI=${1}/icons/hicolor
	rm $DIR_HI/48x48/apps/varicad"$ADDON".png 2>/dev/null
	rm $DIR_HI/32x32/apps/varicad"$ADDON".png 2>/dev/null
	rm $DIR_HI/22x22/apps/varicad"$ADDON".png 2>/dev/null
	rm $DIR_HI/16x16/apps/varicad"$ADDON".png 2>/dev/null
	DIR_LO=${1}/icons/locolor
	rm $DIR_LO/48x48/apps/varicad"$ADDON".png 2>/dev/null
	rm $DIR_LO/32x32/apps/varicad"$ADDON".png 2>/dev/null
	rm $DIR_LO/22x22/apps/varicad"$ADDON".png 2>/dev/null
	rm $DIR_LO/16x16/apps/varicad"$ADDON".png 2>/dev/null
	rm ${1}/applnk/$MENU_GROUP/varicad"$ADDON".desktop 2>/dev/null
	rm ${1}/applnk-mdk/$MENU_GROUP/varicad"$ADDON".desktop 2>/dev/null
}

remove_desktop_entries()
{
	DIR_SHARE=/usr/share
	if test -d $DIR_SHARE; then
		DIR_HI=$DIR_SHARE/icons/hicolor
		if test -d "$DIR_HI" -a -w "$DIR_HI"; then
			rm $DIR_HI/48x48/apps/varicad"$ADDON".png 2>/dev/null
			rm $DIR_HI/32x32/apps/varicad"$ADDON".png 2>/dev/null
			rm $DIR_HI/22x22/apps/varicad"$ADDON".png 2>/dev/null
			rm $DIR_HI/16x16/apps/varicad"$ADDON".png 2>/dev/null
			gtk-update-icon-cache -f $DIR_HI 2> /dev/null
		fi
		DIR_LO=$DIR_SHARE/icons/locolor
		if test -d $DIR_LO -a -w $DIR_LO; then
			rm $DIR_LO/48x48/apps/varicad"$ADDON".png 2>/dev/null
			rm $DIR_LO/32x32/apps/varicad"$ADDON".png 2>/dev/null
			rm $DIR_LO/22x22/apps/varicad"$ADDON".png 2>/dev/null
			rm $DIR_LO/16x16/apps/varicad"$ADDON".png 2>/dev/null
			gtk-update-icon-cache -f $DIR_LO 2> /dev/null
		fi
		if test -d $DIR_SHARE/applications/; then
			rm $DIR_SHARE/applications/varicad"$ADDON".desktop 2>/dev/null
		fi
		if test -d $DIR_SHARE/mimelnk/application/; then
			rm $DIR_SHARE/mimelnk/application/x-varicad"$ADDON".desktop 2>/dev/null
		fi
		update-desktop-database 2> /dev/null
		update-mime-database 2> /dev/null
	fi
  USERS_VCD=$(cut -d ":" -f1 < /etc/passwd)
  for USER_VCD in $USERS_VCD; do
    USER_HOME=$(grep "^$USER_VCD:" /etc/passwd | cut -d ":" -f6)
    if test -d $USER_HOME/Desktop; then
			rm $USER_HOME/Desktop/varicad"$ADDON".desktop 2> /dev/null
    fi
  done
}

update_mandrake_menu()
{
    if test -x /usr/bin/update-menus; then

	rm /usr/lib/menu/varicad 2>/dev/null
	rm /usr/share/icons/varicad"$ADDON".png 2>/dev/null
	rm /usr/share/icons/mini/varicad"$ADDON".png 2>/dev/null
	rm /usr/share/icons/large/varicad"$ADDON".png 2>/dev/null

	/usr/bin/update-menus || true
    fi
}

  ADDON=""
  if test -f varicadview.xpm ; then
    ADDON="view"
  fi
   if test -f varicadtrial.xpm ; then
    ADDON="trial"
  fi 
  MENU_GROUP=Graphics

  remove_icons
  remove_wmconfig
  remove_gnome_entries /opt/gnome/share
  remove_gnome_entries /usr/share/gnome
  remove_kde_entries /opt/kde2/share
  remove_kde_entries /opt/kde3/share
  remove_kde_entries /usr/share
  remove_desktop_entries
  update_mandrake_menu
